Foxit PDF SDK

Public Member Functions | Static Public Attributes | List of all members
FSDK.SignatureCallback Class Reference

## Public Member Functions
| CheckCertificateValidity (cert_path, cert_password, client_data)
| A callback function used to check the validity of a certificate. More...
| ContinueCalcDigest (client_data, pause)
| A callback function used to continue the custom digest calculation process. More...
| GetDigest (client_data)
| A callback function used to get the digest after the calculation process is finished. More...
| Release ()
| A callback function used to release current callback object itself. More...
| Sign (digest, digest_length, cert_file_stream, cert_password, digest_algorithm, client_data)
| A callback function used to do signing and return the signed data. More...
| Sign (digest, digest_length, cert_path, cert_password, digest_algorithm, client_data)
| A callback function used to do signing and return the signed data. More...
| StartCalcDigest (file, byte_range_array, size_of_array, signature, client_data)
| A callback function used to start a custom digest calculation, mainly to initialize the calculation process. More...
| VerifySigState (digest, digest_length, signed_data, signed_data_len, client_data) IsNeedPadData()
| A callback function used to verify the integrity of a signature and return the verify state. More...

## Static Public Attributes
static | e_CertCannotGetPrivateKey
| Certificate's private key cannot be gotten.
static | e_CertDataError
| Certificate's data is error.
static | e_CertExpired
| Certificate is expired.
static | e_CertInvalidPassword
| Certificate's password is wrong.
static | e_CertInvalidPath
| Certificate's path is wrong.
static | e_CertNotSet
| Certificate is not set to sign a signature.
static | e_CertUnsupportType
| Certificate is unsupport type.
static | e_CertValid
| Enumeration for certificate validity. More...

## Detailed Description

This class represent a callback object to sign or verify signature. All the pure virtual functions in this class are used as callback functions and should be implemented by user, in order to sign or verify signature in a customized way.
User can set register customized signature callback object to Foxit PDF SDK by function FSDK.Library.RegisterSignatureCallback with filter and sub filter as the callback name.

See also
  FSDK.Library

## Member Function Documentation

## ◆ CheckCertificateValidity()

FSDK.SignatureCallback.CheckCertificateValidity | ( | cert_path | ,
|  | cert_password | ,
|  | client_data |
| ) |  |

A callback function used to check the validity of a certificate.

This callback function will be triggered when function FSDK.Signature.StartSign is called. If no need to check the certificate, value FSDK.SignatureCallback.e_CertValid can be returned directly.

Parameters

  [in] | cert_path | A full path of a certificate file (including file name and extension), which will be used for signing. This is passed by user from function FSDK.Signature.StartSign.
  [in] | cert_password | A password string used to open the cert file. If this is an empty string, that means no password is required.This is passed by user from function FSDK.Signature.StartSign.
  [in] | client_data | A user-defined object, which is passed by user from function FSDK.Signature.StartSign.

Returns
  Certificate validity. Please refer to values starting from FSDK.SignatureCallback.e_CertValid and it should be one of these values.

## ◆ ContinueCalcDigest()

FSDK.SignatureCallback.ContinueCalcDigest | ( | client_data | ,
|  | pause |
| ) |  |

A callback function used to continue the custom digest calculation process.

Parameters

  [in] | pause | Pause object which decides if the calculation process needs to be paused. If this is null, it means not to pause during the calculation process. If this is not null, please check the the return value of function NeedToPauseNow() of this input parameter and decide when to pause the calculation process.
  [in] | client_data | A user-defined object, which is passed by user from function FSDK.Signature.StartSign or FSDK.Signature.StartVerify.

Returns
  FSDK.Progressive.e_Finished means the rendering is finished successfully.
  FSDK.Progressive.e_ToBeContinued means the calculation process is not finished yet and callback function FSDK.SignatureCallback.ContinueCalcDigest would be triggered again to continue the process.
  FSDK.Progressive.e_Error means any error occurs.

## ◆ GetDigest()

FSDK.SignatureCallback.GetDigest | ( | client_data |  | ) |

A callback function used to get the digest after the calculation process is finished.

This callback function will be triggered when the calculation process is finished successfully.

Parameters

  [in] | client_data | A user-defined object, which is passed by user from function FSDK.Signature.StartSign or FSDK.Signature.StartVerify.

Returns
  The digest string. If there is any error, please return an empty string.

## ◆ Release()

FSDK.SignatureCallback.Release | ( |  | ) |

A callback function used to release current callback object itself.

Returns
  None.

## ◆ Sign() [1/2]

FSDK.SignatureCallback.Sign | ( | digest | ,
|  | digest_length | ,
|  | cert_file_stream | ,
|  | cert_password | ,
|  | digest_algorithm | ,
|  | client_data |
| ) |  |

A callback function used to do signing and return the signed data.

Host application provides this callback function for custom sign mechanism. This callback function would be triggered during the signature signing process.

Parameters

  [in] | digest | The digest data buffer, for source file buffer to be signed.
  [in] | digest_length | The size of digest data buffer.
  [in] | cert_file_stream | A FSDK.StreamCallback object which is implemented by user to access content of a certificate file which will be used for signing.
  [in] | cert_password | The password string, used to open the cert file. If this is an empty string, that means no password is required.
  [in] | digest_algorithm | The algorithm of message digest for signed data. Please refer to values starting from FSDK.Signature.e_DigestSHA1 and this would be one of these values.
  [in] | client_data | A user-defined object, which is passed by user from function FSDK.Signature.StartSign or FSDK.Signature.StartVerify.

Returns
  Signed data. If there is any error, please return an empty string.
  The length of returned signed data should be within the default length of signature contents which is 7942 by default or specified by fucntion FSDK.Signature.SetDefaultContentsLength before signing the unsigned signature.

## ◆ Sign() [2/2]

FSDK.SignatureCallback.Sign | ( | digest | ,
|  | digest_length | ,
|  | cert_path | ,
|  | cert_password | ,
|  | digest_algorithm | ,
|  | client_data |
| ) |  |

A callback function used to do signing and return the signed data.

Host application provides this callback function for custom sign mechanism. This callback function would be triggered during the signature signing process.

Parameters

  [in] | digest | The digest data buffer, for source file buffer to be signed.
  [in] | digest_length | The size of digest data buffer.
  [in] | cert_path | The certificate file path, which will be used for signing.
  [in] | cert_password | The password string, used to open the cert file. If this is an empty string, that means no password is required.
  [in] | digest_algorithm | The algorithm of message digest for signed data. Please refer to values starting from FSDK.Signature.e_DigestSHA1 and this would be one of these values.
  [in] | client_data | A user-defined object, which is passed by user from function FSDK.Signature.StartSign or FSDK.Signature.StartVerify.

Returns
  Signed data. If there is any error, please return an empty string.
  The length of returned signed data should be within the default length of signature contents which is 7942 by default or specified by fucntion FSDK.Signature.SetDefaultContentsLength before signing the unsigned signature.

## ◆ StartCalcDigest()

FSDK.SignatureCallback.StartCalcDigest | ( | file | ,
|  | byte_range_array | ,
|  | size_of_array | ,
|  | signature | ,
|  | client_data |
| ) |  |

A callback function used to start a custom digest calculation, mainly to initialize the calculation process.

Parameters

  [in] | file | When signing a signature, this represents the source file object to be signed. When verifying a signature field, this represents the source file object to be verified.
  [in] | byte_range_array | A byte range array of the signed document(not the source document). Elements in this array always be in pairs of offset-size values in order of: offset,size,offset,size...
  [in] | size_of_array | Count of elements in the byte range array byte_range_array.
  [in] | signature | A signature object.
  [in] | client_data | A user-defined object, which is passed by user from function FSDK.Signature.StartSign, FSDK.Signature.StartVerify.

Returns
  true means the calculation process is successfully started and then FSDK.SignatureCallback.ContinueCalcDigest will be triggered to continue the calculation process. false means fail to start a calculation process.

## ◆ VerifySigState()

FSDK.SignatureCallback.VerifySigState | ( | digest | ,
|  | digest_length | ,
|  | signed_data | ,
|  | signed_data_len | ,
|  | client_data |
| ) |  |

A callback function used to verify the integrity of a signature and return the verify state.

Host application provides this callback function for custom sign mechanism. This callback function would be triggered during the signature verifying process.
From 7.0, this callback function is only used to verify the intergrity of a signature. Please check the comment about return value for more details.

Parameters

  [in] | digest | The digest data buffer, for source file buffer to be verified.
  [in] | digest_length | The size of digest data buffer.
  [in] | signed_data | The signed data buffer.
  [in] | signed_data_len | The size of signed data buffer.
  [in] | client_data | A user-defined object, which is passed by user from function FSDK.Signature.StartSign or FSDK.Signature.StartVerify.

Returns
  Verify state:
  - Please return FSDK.Signature.e_StateVerifyNoChange alone to indicate that the document has not been changed within the scope of the signature.
  - Otherwise, please return FSDK.Signature.e_StateVerifyChange alone or combined with other error state value.

A callback function used to check whether to return all contents with padding zero or not, when callback function FSDK.SignatureCallback.VerifySigState is called.

Returns
  true means to return all data in contents steam (including padding zero), while false means to return contents data without padding zero in stream end.

## Member Data Documentation

## ◆ e_CertValid

FSDK.SignatureCallback.e_CertValid
| static

Enumeration for certificate validity.

Values of this enumeration should be used alone.

Certificate is valid.